import processing.sound.*;
SinOsc sine;
Env env;


Table corpus;
ArrayList <Element> arr =  new ArrayList<Element>();
int scope = 800; 
int[] years = new int[0];
int[] drawYears = new int[scope]; 
int datamin = 0; 
int datamax = 0; 
PFont freight; 
String currtext= "";
int currSnd = 0; 
int oldSnd = 0;
void setup() {
  size(800, 800);
  smooth(8);
  freight = createFont("FreightSansProBook-Regular-20.vlw", 20);
  corpus = loadTable("Met.csv", "header");
  int records = corpus.getRowCount();
  println("corpus has "+records+" records!");

  for (TableRow row : corpus.rows()) {
    int yr = row.getInt("AccessionYear");
    if (yr != 0) {
      arr.add(new Element(yr));
    }
  }
  for (int i = 0; i < arr.size(); i++) {
    years = append(years, arr.get(i).year);
  }
  years = sort(years); 
  println("array size = "+years.length);
  datamin = min(years);
  datamax = max(years);

  println("array min = "+min(years));
  println("array max = "+max(years));
  // create and start the sine oscillator.
  sine = new SinOsc(this);
  //sine.play();
  // Create the envelope 
  env  = new Env(this); 
}

void draw() {
  background(0, 200, 0);

  //do something to show the data: a side-scroller
  int offset = frameCount%(years.length-scope);
  println(offset); 
  //push data into drawing array
  arrayCopy(years, offset, drawYears, 0, scope); 
  for (int i = 0; i < scope; i++) {
    int x0 = i;
    float y0 = map(drawYears[i], datamin, datamax, 0, 800);
    fill(map(drawYears[i], datamin, datamax, 0, 255));
    noStroke(); 
    rect (x0, 800, 1, -1*y0);
    currtext = str(drawYears[400]);
    currSnd = drawYears[400]; 
  }
  fill(255);
  textFont(freight, 20);
  textSize(20);
  textAlign(CENTER, CENTER);
  text(currtext, 400, 700);
  stroke(255); 
  line(400,100, 400, 650); 
  if (currSnd != oldSnd){
  playSound(currSnd);
  oldSnd = currSnd; 
  }
} 
